Summary:	UPS power management under Linux for APCC Products.
Name:		apcupsd
Version:	3.6.1
Release:	2hurl
Vendor:		APC UPS Daemon Team
Packager:	HURL <hurl@headgear.org>
URL:		http://www.brisse.dk/site/apcupsd/
Source:         http://www.brisse.dk/dlarea/apcupsd-%{version}.tar.gz
Patch:          apcupsd-3.6.1-hurl.patch
Patch1:         apcupsd-3.6.1-libs.patch
Group:		System Environment/Daemons
Copyright:	GPL
#Icon:		apcupsd.gif
BuildRoot:	/var/tmp/%{name}-%{version}

%description
APCupsd allows your computer/server to run during power problems for a
specified length of time or until the batteries in your BackUPS, BackUPS Pro,
SmartUPS v/s, or SmartUPS die.  During an extended power failure, it properly
executes a controlled shutdown.

The following UPS hardware is supported:
  Full: BackUPS, BackUPS Pro, SmartUPS V/S, and SmartUPS(NET/RM)
        SmartUPS V/S is untested, but should be okay.
  Beta: MatrixUPS and ShareUPS

The following APC cables are supported:
  Full: 940-0020B, 940-0024B, 940-0024C, 940-0095A,
        940-0095C(maybe), 940-0023A(Last resort, please pick another.)
    
APCaccess is the IPC management tool for "apcupsd".
APCaccess is used to manage slaves locally.

%package powerflute
Summary: Powerflute curses-based interface to apcupsd
Requires: apcupsd
Group: Applications/System

%description powerflute
Powerflute is a curses-based interface to apcupsd.

%prep
%setup
%patch -p1

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --sbindir=/sbin --enable-powerflute --disable-nls --enable-threads
cat %{PATCH1} | patch -p1
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{dev,etc/rc.d/init.d,usr/{bin,man/man8,lib/apcupsd},sbin,var/lock/apcupsd}
make install prefix=$RPM_BUILD_ROOT/usr sbindir=$RPM_BUILD_ROOT/sbin
make install-powerflute prefix=$RPM_BUILD_ROOT/usr sbindir=$RPM_BUILD_ROOT/sbin
cp redhat/apcups* $RPM_BUILD_ROOT/etc/rc.d/init.d/apcupsd
ln -s whatever_port_your_UPS_is_connected_to $RPM_BUILD_ROOT/dev/ups

%postun
if [ "$1" = "0" ]; then
  chkconfig --del apcupsd
fi

%clean
#rm -rf $RPM_BUILD_ROOT

%files
%defattr (644, root, root, 755)
%doc COPYING ChangeLog INSTALL TODO doc/* examples/*
%defattr (755, root, root)
/sbin/apcupsd
/sbin/apcaccess
/sbin/powersc
%defattr (644, root, man)
/usr/man/man8/*
%attr(755,root,root) %dir /usr/lib/apcupsd
%attr(755,root,root) %dir /var/lock/apcupsd
%config(noreplace) /dev/ups

%files powerflute
%defattr(755, root, root)
/sbin/powerflute

%changelog
* Sun Jul 11 1999 Cloyce D. Spradling <cloyce@headgear.org>
- massive surgery on spec file
- split functionality into separate packages
